<?php

namespace App\Http\Requests\Admin;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Validation\ValidationException;
use Illuminate\Http\Exceptions\HttpResponseException;

/**
 * @property mixed email
 * @property mixed message
 * @property mixed visitor_email
 * @property mixed reply
 * @property mixed name
 * @property mixed subject
 */
class VisitorMessageRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (Auth::guest()) {
            return true;
        }
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin', 'sub_admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule( 'visitorMessages' ) )
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules = [];
        if (Auth::user() && Auth::user()->role){
            $admin_rules = [
                'visitor_email' => 'required|email',
                'reply' => 'required|min:10',
            ];

            $rules = array_merge($rules, $admin_rules);

        } else{

            $visitor_rules = [
                'name' => 'required',
                'email' => 'required',
                'subject' => 'required',
                'message' => 'required',
            ];

            $rules = array_merge($rules, $visitor_rules);
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('visitorMessages');
        $local = getCurrentLocale();
        $attributes = [
            'name' => $field[$local]['name'] ?? __('visitorMessages.name'),
            'email' => $field[$local]['email'] ?? __('visitorMessages.email'),
            'subject' => $field[$local]['subject'] ?? __('visitorMessages.subject'),
            'message' => $field[$local]['message'] ?? __('visitorMessages.message'),
            'visitor_email' => $field[$local]['visitor_email'],
            'reply' => $field[$local]['reply'],
        ];

        return $attributes;
    }
    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::ajax()){
            $errors = $validator->errors()->first();
            throw new HttpResponseException(response()->json(['errors' => $errors]));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
